<html>
<head>
<title>OgreSimpleSpline.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSimpleSpline.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSimpleSpline_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __SimpleSpline_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __SimpleSpline_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreVector3_8h.html">OgreVector3.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreMatrix4_8h.html">OgreMatrix4.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00056"></a><a class="code" href="classOgre_1_1SimpleSpline.html">00056</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SimpleSpline.html" title="A very simple spline class which implements the Catmull-Rom class of splines.">SimpleSpline</a>
<a name="l00057"></a>00057     {
<a name="l00058"></a>00058     <span class="keyword">public</span>:
<a name="l00059"></a>00059         <a class="code" href="classOgre_1_1SimpleSpline.html" title="A very simple spline class which implements the Catmull-Rom class of splines.">SimpleSpline</a>();
<a name="l00060"></a>00060         ~<a class="code" href="classOgre_1_1SimpleSpline.html" title="A very simple spline class which implements the Catmull-Rom class of splines.">SimpleSpline</a>();
<a name="l00061"></a>00061 
<a name="l00063"></a>00063         <span class="keywordtype">void</span> addPoint(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; p);
<a name="l00064"></a>00064 
<a name="l00066"></a>00066         <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; getPoint(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index) <span class="keyword">const</span>;
<a name="l00067"></a>00067 
<a name="l00069"></a>00069         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> getNumPoints(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00070"></a>00070 
<a name="l00072"></a>00072         <span class="keywordtype">void</span> clear(<span class="keywordtype">void</span>);
<a name="l00073"></a>00073 
<a name="l00078"></a>00078         <span class="keywordtype">void</span> updatePoint(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; value);
<a name="l00079"></a>00079 
<a name="l00086"></a>00086         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> interpolate(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> t) <span class="keyword">const</span>;
<a name="l00087"></a>00087 
<a name="l00092"></a>00092         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> interpolate(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> fromIndex, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> t) <span class="keyword">const</span>;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00107"></a>00107         <span class="keywordtype">void</span> setAutoCalculate(<span class="keywordtype">bool</span> autoCalc);
<a name="l00108"></a>00108 
<a name="l00114"></a>00114         <span class="keywordtype">void</span> recalcTangents(<span class="keywordtype">void</span>);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116     <span class="keyword">protected</span>:
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="classOgre_1_1SimpleSpline.html#af6c6e592a24de4a8ba44077eb00cce02">00118</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1SimpleSpline.html#af6c6e592a24de4a8ba44077eb00cce02">mAutoCalc</a>;
<a name="l00119"></a>00119 
<a name="l00120"></a><a class="code" href="classOgre_1_1SimpleSpline.html#abfedd02e64b6d03b82c46c3ebd37a90f">00120</a>         <a class="code" href="structOgre_1_1vector.html">vector&lt;Vector3&gt;::type</a> <a class="code" href="classOgre_1_1SimpleSpline.html#abfedd02e64b6d03b82c46c3ebd37a90f">mPoints</a>;
<a name="l00121"></a><a class="code" href="classOgre_1_1SimpleSpline.html#a2a795b529c48668850d8c701b4b65926">00121</a>         <a class="code" href="structOgre_1_1vector.html">vector&lt;Vector3&gt;::type</a> <a class="code" href="classOgre_1_1SimpleSpline.html#a2a795b529c48668850d8c701b4b65926">mTangents</a>;
<a name="l00122"></a>00122 
<a name="l00124"></a><a class="code" href="classOgre_1_1SimpleSpline.html#a1f4270a81d2a5f8580b8e5652407998e">00124</a>         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1SimpleSpline.html#a1f4270a81d2a5f8580b8e5652407998e" title="Matrix of coefficients.">mCoeffs</a>;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     };
<a name="l00129"></a>00129 
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="preprocessor">#endif</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
